extends Node3D

enum weap {
	WaltherP5
}

var current_weap : int = 1
@export var cam : Node
@export var weap_1 : weap
@export var weap_2 : weap
@export var weap_models : Node
#@onready var weap_anims : AnimationPlayer = weap_models.get_node("AnimationPlayer")
@export_flags_3d_physics var mask_all
@onready var main = get_tree().root.get_child(0)
@export var player : Node
@export var bullet_hole : Resource

func _ready():
#	weap_anims.animation_finished.connect(fin)
	pass # Replace with function body.


func _process(delta):
	pass

#func fin(_crap):
#	print("done!")

func _input(event):
	if Input.is_action_just_pressed("fire"):
		fire_weap()


func fire_weap():
	var col = raycast()
	var bul_inst = bullet_hole.instantiate()
	main.add_child(bul_inst)
	bul_inst.position = col.position
	bul_inst.rotation = col.normal

func raycast():
	var center_screen = get_viewport().size * 0.5
	var ray_length = 10000
	var from = cam.project_ray_origin(center_screen)
	var to = from + cam.project_ray_normal(center_screen) * ray_length
	var query = PhysicsRayQueryParameters3D.create(from, to)
	var collision = get_world_3d().direct_space_state.intersect_ray(query)
	return collision
